sub cgiSOAP {

	# Title: 	WISDOM: Woda Interface to SOAP without XML DOM
	# Version:	2.2 beta
	# Date:		12.11.2003
	# Author:	Tomo Cerovsek <tcerovse@fgg.uni-lj.si>
	
	local($out, $file, $xmlin);
	
	$xmlin = $CGI{xml};
	
	# praov bi blo da bi ze kar tuki poparsu 
	# XML, ki pride noter
	
	if ($xmlin =~ m/\>\n\<methodCall/i) {
		mkXMLRPC($xmlin);
	} else {
		mkSOAP($xmlin);
	}

}

sub mkSOAP {
	local($xmlin) = @_;
	
	local ($soapEnc, $soapEnv, $soapHdr, $soapBdy, $soapEnd, $soapMsg, $search);
	
	# vecina klientov se obesi, ce ne dobi
	# podatkov v UTF-8 data ->UTF print?
	# nekateri poznajo ISO 8859-1 ?
	$soapEnc ="UTF-8";


	$soapEnv = <<EOM;
<?xml version="1.0" encoding="$soapEnc"?>
<SOAP-ENV:Envelope 
	xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
	SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
	xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
	xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" 
	xmlns:xsd="http://www.w3.org/1999/XMLSchema">
EOM

	# add some soap headers if you like
	$soapHdr =<<EOM;
EOM

# soapaction ... pove katera metoda se naj poklice
# to je to kar je SOAPSearch
# $ENV{SOAP-Action} ... al neki tacga

# drugac bi moral uporabiti XML::Parser ...
# za silo dobim parametre takole ....
$xmlin =~ m/\<[^\>]*search[^\>]*\>([^\<\n]*)[\<\n]/;
$search = $1;

$soapCon = &SOAPsearch('',$search);

	# watch on namespaces!!
	$soapBdy =<<EOM;
	<SOAP-ENV:Body>
		<ns1:SOAPResponse xmlns:ns1="$SCRIPTBASE$SCRIPTNAME">
$soapCon
EOM

$soapEnd =<<EOM;
		</ns1:SOAPResponse>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>
EOM


$soapMsg =<<EOM;
$soapEnv
$soapHdr
$soapBdy
$soapEnd
EOM

$soapMsg = iso2utf8($soapMsg);

print $HTTP200OK . "Content-type: text/xml\n";
print "Content-Length: " . flength($soapMsg);
print "\n\n";
print $soapMsg; 

exit;

}

sub SOAPsearch {
	local($table,$search,$then,$sort,$first,$max,$flds) = @_;
	local($out);
	
	$max = 1000;
     	$out = &QRY($table,$search,$then,$sort,'XML',$first,$max,$flds);
   	# $out =~ s/\<\/?records\>//ig;
     	# $out = &ROWS($table,$flds,$search,$sort,'XML',$flds);
	
	# imenski prostori XML responsa prilagojeni SOAP:Lite
	$out =~ s/\<rec _id/$allRecs++ ; qq!<rec xsi:type="ns1:rec" _id!;/ge;
	
	$out =~ s/((\<\!DOCTYPE\s+records\>)|(<\/?records>))//g;
	$allRecs = $allRecs+0;
    
    return <<EOM;
    			<results xsi:type="ns1:records">
				<records 
					xmlns:ns2="http://schemas.xmlsoap.org/soap/encoding/" 
					xsi:type="ns2:Array" ns2:arrayType="ns1:rec[$allRecs]">
$out
				</records>
			</results>
EOM

}

sub SOAPfault {
	local($type, $msg) = @_;
	
	if ($type eq "server") {
		return <<EOM;
		<SOAP-ENV:Fault>
			<faultcode xsi:type="xsd:string">SOAP-ENV:Server</faultcode>
			<faultstring xsi:type="xsd:string">Server error $msg</faultstring>
		</SOAP-ENV:Fault>
EOM

	} else {
		return <<EOM;
				<SOAP-ENV:Fault>
			<faultcode xsi:type="xsd:string">SOAP-ENV:Client</faultcode>
			<faultstring xsi:type="xsd:string">You made something wrong: $msg</faultstring>
		</SOAP-ENV:Fault>
EOM

	}
		
}

sub mkXMLRPC {

#	use strict;
#	use Frontier::RPC2;
	
	my($xmlin) = @_;
	

	 
	 my $coder = Frontier::RPC2->new;
	 $methods = {'sample.imeRutine' => \&imeRutine};
     
     $xmlrpcMsg = $coder->serve($xmlin, $methods);
	
print "Content-type: text/xml\n";
print "Content-Length: " . flength($soapMsg);
print "\n\n";
print $xmlrpcMsg; 

}



# neumni hacki da dobim ta prav content-length??
sub flength {

    local($str) = @_;
    $file = "$DATADIR/_tmp/SOAP" . time . "-" . length($str) . ".xml";
    open (h,">$file");
    print h $str;
    close h;
 
    @f = stat($file);
    return $f[7];
}

sub iso2utf8 {

        my ($string) = @_;
		my %cache = ();
		
        $string =~ s/([\x80-\xff])/$cache{$1} ||= encode_iso($1)/eg;
        return $string;

}

sub encode_iso {

	my $iso = ord($_[0]);
	my $a = ((($iso & 0xc0) >> 6) | 0xc0);
	my $b = ($iso & 0x3f) | 0x80;
	return chr($a) . chr($b);
}



1;