
	# Title: 	MATRA: Transaction matrix analyzer
	# Version:	0.5 beta
	# Date:		17.04.2004
	# Author:	Tomo Cerovsek <tcerovse@fgg.uni-lj.si> 

sub cgiTransactionMatrix {
	
	do printHead("Transaction Matrix Anylzer");

if ($CGI{logFile} eq "") {
	opendir (D,"$DATADIR/_log");
	@f = readdir(D);
	closedir(D);

	@f = grep(/\.log/,@f);
	@f = sort(@f); 	
	
	print <<EOM;
	<form action="$SCRIPT/TransactionMatrix">
	
EOM
	
	foreach $f (@f) {
		
		push (@flds,qq(<INPUT NAME="logFile" TYPE=CHECKBOX value="$f">&nbsp;$f \n));	
		
	}
	
	push (@flds,&formatCheckAllJavaScript('logFile'));
	$eflds = &formatColumns(4,@flds); 
	
	print "<hr>$eflds<hr><input type=submit value=Submit></form>";

} else {
	
	@lf = split (/\n/, $CGI{logFile});
	
	@matrix = ("searchmatrix", "showmatrix", "basketmatrix");
	
	foreach (@matrix) {
	
		rename ("$DATADIR/_log/$_", "$DATADIR/_log/$_.bkp");
	}
	
	
	$sessionId = 10000;
	
	foreach $lf (@lf) {
		
	    print <<EOM;
<h2 >Parsing log file: $lf ....		
EOM

 	    do parseLog2Matrix($lf);
	    print "finished<h2><br>";
 	
		
	}
	
}
	
}

sub parseLog2Matrix {
	
	local($logfile) = @_;
	local($idle, $cmdCol, $parCol, $timCol, $ipsCol);
	
	#use Time::Local;
	
	open (h,"$DATADIR/_log/$logfile");

	$idle = 30;  #ce miruje vec kot tolk minut ... nov session
	
	$cmdCol = 8; # 8 woda
	$parCol = 9; # 9 woda
	$timCol = 2; # 2 woda
	$ipsCol = 3; # 3 woda

	while (<h>) {
	    @cols=split(/\s/,$_);
	    $cols[$timCol] =~ s/\[([^\s]*)/timelocal(&formatTime("$1"));/eo;
		if ($cols[$timCol] - $sessionTime{$cols[3]} > $idle*60) {
			$sessionId++ ;
			$session{$cols[$ipsCol]} = $sessionId;
		}

		$sessionTime{$cols[$ipsCol]} = $cols[$timCol];

		$showmatrix{$session{$cols[$ipsCol]}}   .=  &getParsPar($cols[$parCol],"_id")     if ($cols[$cmdCol] =~ m/Show|Go/);
		$searchmatrix{$session{$cols[$ipsCol]}} .=  &getParsPar($cols[$parCol],"search")  if ($cols[$cmdCol] =~ m/Search/);
		$basketmatrix{$session{$cols[$ipsCol]}} .=  &getParsPar($cols[$parCol],"_id")     if ($cols[$cmdCol] =~ m/BasketAdd/);
	}
	close (h);
	
	do printHash("showmatrix");
	do printHash("searchmatrix");
	do printHash("basketmatrix");
}
	

sub printHash {
	
	local($matrix) = @_;
	local($id);
		
	open (t,">>$DATADIR/_log/$matrix");	
	    foreach $id (sort((keys(%$matrix)))) {
		print t "$id\t$$matrix{$id}\n";
	    }
	close (t);
}

	
sub getParsPar{

	local($pars,$par)=@_;
	local($out);
	
	$pars =~ s/$par=([^\&\s]*)/$out .= "$1\t";/ge;
	$pars =~ s/id([^\=]*)\=on/$out .= "$1\t";/ge;

	return $out; 
}


sub relMatrix  {

	local($matrix, $refId, $relNum) = @_;
	local($filtered, @list, @seeAlso, %cnt, $id);
	
	open (h,"$DATADIR/_log/$matrix");
	    @list = <h>;
	close (h);
	
	@filtered = grep(/$refId/i,@list);
	
	$filtered = join('', @filtered);
	
# print $filtered . "\n";

# prvi t izloi sene	--  hh

	$filtered =~ s/\t([^\t\n]+)/$cnt{$1}++ ;/ge;
	
	delete($cnt{$refId});
	
	foreach $id (sort{$cnt{$b} <=> $cnt{$a}}(keys(%cnt))) {
		push(@seeAlso, "$id\t$cnt{$id}");
	}
	
	return @seeAlso[1..5];

}

1;