sub cgiWSDL {

	# Title: 	WIWA: WSDL generator for WODA
	# Version:	1.0 beta
	# Date:		12.11.2003
	# Author:	Tomo Cerovsek <tcerovse@fgg.uni-lj.si>

	local(@fields)=@_; 
	local($serviceName, $n, @operations);
	
	@operations = ("Show", "Search", "Xput", "XputMany");
	
	$serviceName = "$WBB{'dbTitle'}";
	
	@fields = &visibleFields(@fields) if (@fields < 1);
	

	####### WSDL HEAD and FOOT #######
	$wsdlHead = <<EOM;
<?xml version="1.0" encoding="utf-8"?>
<definitions 	xmlns="http://schemas.xmlsoap.org/wsdl/"
		xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" 
		xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" 
		xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" 
		xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" 
		xmlns:tm="http://microsoft.com/wsdl/mime/textMatching/" 
		xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
		xmlns:tns="$SCRIPTBASE$SCRIPT"
		targetNamespace="$SCRIPTBASE$SCRIPT">
EOM
	$wsdlFoot = <<EOM;
</definitions>
EOM


	####### WSDL DATA TypeS #######
	
	$wsdlTypes =<<EOM;
<types>
	<xsd:schema elementFormDefault="qualified" targetNamespace="$SCRIPTBASE$SCRIPT">
EOM

	# 1. WSDL DATA TYPES part 1: common to all woda data types: 
	# db elementes: rec, records + basic types: string, int 
	
	$wsdlTypes .=<<EOM;
		<xsd:complexType name="rec">
			<xsd:sequence>
EOM

	foreach $n (@fields) { 
		$wsdlTypes .= qq!				<xsd:element name="$n" type="xsd:string"/>\n!;
	}
		
	$wsdlTypes .=<<EOM;
			</xsd:sequence>
		</xsd:complexType>
		
		<xsd:complexType name="records">
			<xsd:sequence>
				<xsd:element name="recs" type="tns:rec"/>
			</xsd:sequence>
		</xsd:complexType>

EOM

### MODIFY HERE
	# WSDL: Data types: Part 2 any additional data types go here
	# jnust uncomment following lines
#	$wsdlTypes .=<<EOM;
#<xsd:complexType:element name="typeName">
# ...
#</xsd:complexType>
#EOM	

	
	$wsdlTypes .= <<EOM;
	</xsd:schema>
</types>
EOM


	####### WSDL MESSAGES #######
# MODIFY HERE
	# provide following pairs for each message
	$wsdlMessage .=<<EOM;
	<message name="SearchInputSoap">
		<part name="search" type="xsd:string"/>
		<part name="format" type="xsd:string"/>
		<part name="fields" type="xsd:string"/>
	</message>
	<message name="SearchOutputSoap">
		<part name="return" element="tns:records"/>
	</message>
	<message name="ShowInputSoap">
		<part name="format" type="xsd:string"/>
		<part name="id" type="xsd:string"/>
		<part name="fields" type="xsd:string"/>
	</message>
	<message name="ShowOutputSoap">
		<part name="return" element="tns:rec"/>
	</message>
EOM
	foreach $operationName (@operations) {
		$wsdlMessage .=<<EOM;
	<message name="$operationName\Input"/>
	<message name="$operationName\Output">
		<part name="Body" element="tns:string"/>
	</message>
EOM
	
	}

	####### WSDL PORTS #######
### SOAP
	$wsdlPorts .=<<EOM;
	<portType name="WodaSoap">
EOM

### for each operation / function

	foreach $operationName (@operations) {
	
		$wsdlPorts .=<<EOM;
		<operation name="$operationName">
			<input message="tns:$operationName\InputSoap"/>
			<output message="tns:$operationName\OutputSoap"/>
		</operation>
EOM
	}
	

### GET
	$wsdlPorts .=<<EOM;	
</portType>
EOM

	$wsdlPorts .=<<EOM;
	<portType name="WodaHttpGet">
EOM

### for each operation
	foreach $operationName (@operations) {
		$wsdlPorts .=<<EOM;
		<operation name="$operationName">
			<input message="tns:$operationName\Input"/>
			<output message="tns:$operationName\Output"/>
		</operation>
EOM
	}

	$wsdlPorts .=<<EOM;	
</portType>
EOM


### POST
$wsdlPorts .=<<EOM;
	<portType name="WodaHttpPost">
EOM

	### for each operation
	foreach $operationName (@operations) {
		$wsdlPorts .=<<EOM;
		<operation name="$operationName">
			<input message="tns:$operationName\Input"/>
			<output message="tns:$operationName\Output"/>
		</operation>
EOM
	}

	$wsdlPorts .=<<EOM;	
</portType>
EOM
	

	####### WSDL BINDING #######
	
	# SOAP binding
	$wsdlBinding .=<<EOM;
<binding name="WodaSoap" type="tns:WodaSoap">
	<soap:binding transport="http://schemas.xmlsoap.org/soap/http" style="document"/>

EOM


	foreach $operationName (@operations) {
	$wsdlBinding .=<<EOM;
	<operation name="$operationName">
		<soap:operation soapAction="$SCRIPTBASE$SCRIPTNAME/$operationName" style="document"/>
		<input>
			<soap:body use="literal"/>
		</input>
		<output>
			<soap:body use="literal"/>
		</output>
	</operation>
EOM
	}

	$wsdlBinding .=<<EOM;	
</binding>
EOM

	$wsdlBinding .=<<EOM;
<binding name="WodaHttpGet" type="tns:WodaHttpGet">
	<http:binding verb="GET"/>
EOM

	foreach $operationName (@operations) {
		$wsdlBinding .=<<EOM;
	<operation name="$$operationName">
		<http:operation location="$SCRIPTBASE$SCRIPTNAME/$operationName"/>
		<input>
			<http:urlEncoded/>
		</input>
		<output>
			<mime:mimeXml part="Body"/>
		</output>
	</operation>
EOM
	}
	
	$wsdlBinding .=<<EOM;	
</binding>
EOM
	
		$wsdlBinding .= <<EOM;
<binding name="WodaHttpPost" type="tns:WodaHttpPost">
	<http:binding verb="POST"/>
EOM

	foreach $operationName (@operations) {
	
		$wsdlBinding .=<<EOM;
	<operation name="$operationName">
		<http:operation location="$SCRIPTBASE$SCRIPTNAME/$operationName"/>
		<input>
			<mime:content type="application/x-www-form-urlencoded"/>
		</input>
		<output>
			<mime:mimeXml part="Body"/>
		</output>
	</operation>
EOM
	}


	$wsdlBinding .=<<EOM;
</binding>
EOM


	####### WSDL SERVICE ENTRY #######

	$wsdlService =<<EOM;
<service name="WodaService">
	<port name="WodaSoap" binding="tns:WodaSoap">
		<soap:address location="$SCRIPTBASE$SCRIPT/SOAP"/>
	</port>
	<port name="WodaHttpGet" binding="tns:WodaHttpGet">
		<http:address location="$SCRIPTBASE$SCRIPT"/>
	</port>
	<port name="WodaHttpPost" binding="tns:WodaHttpPost">
		<http:address location="$SCRIPTBASE$SCRIPT"/>
	</port>
</service>
EOM

	# Make WSDL
	$WSDL = <<EOM;
$wsdlHead
$wsdlTypes
$wsdlMessage
$wsdlPorts
$wsdlBinding
$wsdlService
$wsdlFoot
EOM

	# printing
	print $HTTP200OK . "Content-type: text/xml\n\n"; 
	print $WSDL;

}

1;